/**
 * object storing data about AIP concentration inside biofilm
 * 
 * @author Shing Hei Zhan, University of British Columbia 2010 iGEM team
 * @version 1.0 Oct. 27, 2010
 */
public class AIP
{
    // state
    private double AIPprev;
    private double AIP;
    // parameters
    private double sigmaRate;
    private double gammaRate;
    private double AIPmax;
    private double AIPthres;
    private double carryCap;
    
    public AIP(double iniAIP, double psigmaRate, double pgammaRate, double pAIPmax, double pAIPthres, double pcarryCap)
    {
        AIP = iniAIP;
        sigmaRate = psigmaRate;
        gammaRate = pgammaRate;
        AIPmax = pAIPmax;
        AIPthres = pAIPthres;
        carryCap = pcarryCap;
    }

    public double getAIPprev()
    {
        return AIPprev;
    }
    
    public double getAIP()
    {
        return AIP;
    }
    
    public double updateAIP(double BT)
    {
        // update
        AIPprev = AIP;
        double term1 = sigmaRate * (1 - BT/carryCap) * (1 - AIP/AIPmax);
        double term2 = - gammaRate * AIP;
        AIP += term1 + term2;
        // return value
        return AIP;
    }
}