/**
 * @author Shing Hei Zhan, University of British Columbia 2010 iGEM team
 * @version 1.0 Oct. 27, 2010
 */
public class History
{
    // 2-d array storing history of variable values
    // 1) BT, 2) Bu, 3) Bi, 4) BL, 5) Bl, 6) P, 7) AIP, 8) DspB, 9) rate, 10) layer, 11) depth, 12) eps
    private double[][] history;
    private final int rowLen = 12;
    private int colLen;
    
    /**
     * Constructor for objects of class History
     */
    public History(int genNum)
    {
        history = new double[genNum][rowLen];
        colLen = genNum;
    }

    /**
     * access methods
     */
    public int getRowLen()
    {
        return rowLen;
    }

    public int getColLen()
    {
        return colLen;
    }

    public double[] getRowVal(int rowNum)
    {
        return history[rowNum];
    }
    
    public double[] getColVal(int colNum)
    {
        double[] vals = new double[colLen];
        for(int x = 0; x < colLen; x++){
            vals[x] = history[x][colNum];
        }
        return vals;
    }
    
    public void updateHistory(double[] vars, int genNum){
        history[genNum] = vars;
    }
}